<?php
/**
 * This Class reads the csv files in the YellowCube config folder
 *
 * Entwicklung: 	Zangger Websolutions
 * Web:			www.ihrewebagentur.ch
 * Projekt:		www.yellowcube.ihrewebagentur.ch
 * @version:		4.0
 */

class CsvReader
{

    public function __construct()
    {
    }

    /**
    * Read the orderstatus or the payment CSV File create an Array
    * @param string $fileName The Filename of the CSV (Constant)
    * @throws Exception When the File cannot be read
    * @return array payment methodes array
    */
    public function readConfig($fileName)
    {
        try {
            $csv_datei = dirname(__FILE__)."/../../config/".$fileName;
            $content = fopen($csv_datei, "r");
            $paymentmethods = array();
            while (($dataArray = fgetcsv($content, 0, ";")) !== false) {
                foreach ($dataArray as $data) {
                    array_push($paymentmethods, utf8_encode($data));
                }
            }
            return $paymentmethods;
        } catch (Exception $e) {
            Logger::addLog("Error reading File:".$fileName, 4);
            throw new Exception($e->getMessage());
        }
    }

    /**
    * Read the shippingproducts CSV File create an Array that contains an array for each shippingproduct
    * @param string $fileName The Filename of the CSV (Constant)
    * @throws Exception When the File cannot be read
    * @return array A shippingproduct array
    */
    public function readCarriers($fileName)
    {
        try {
            $csv_datei = dirname(__FILE__)."/../../config/".$fileName;
            $content = fopen($csv_datei, "r");
            $shippingproducts = array();

            while (($dataArray = fgetcsv($content, 0, ",")) !== false) {
                $array = array();
                foreach ($dataArray as $data) {
                    array_push($array, utf8_encode($data));
                }
                array_push($shippingproducts, $array);
            }
            return $shippingproducts;
        } catch (Exception $e) {
            Logger::addLog("Error reading File:".$fileName, 4);
            throw new Exception($e->getMessage());
        }
    }
}
