<?php
/**
 * mailprovider short summary.
 *
 * mailprovider description.
 *
 * Entwicklung: 	Zangger Websolutions
 * Web:			www.ihrewebagentur.ch
 * Projekt:		www.yellowcube.ihrewebagentur.ch
 * @version:		4.0
 */

include_once(dirname(__FILE__).'/../const.php');

class MailProvider
{
    public function __construct()
    {
    }

    /**
     * Send an e-mail to a customer, when his order received a trackingnumber from YellowCube.
     * @param string $oderRef The PrestaShop Order Reference
     * @param string $customerId The Customer ID
     * @param string $trackingNumber The Trackingnumber from YellowCube
     */
    public function sendTrackingEmail($oderRef, $customerId, $trackingNumber)
    {
        $customer = new Customer($customerId);
        $templateVars = array();
        $templateVars['{firstname}'] = $customer->firstname;
        $templateVars['{lastname}'] = $customer->lastname;
        $templateVars['{prestaref}'] = $oderRef;
        $templateVars['{tracking}'] = $trackingNumber;
        $templateVars['{shopname}'] = Configuration::get('PS_SHOP_NAME');
        $template_name = Constants::TEMPLATENAME;
        $title = MailProvider::getMailTitel($customer->id_lang).$oderRef;
        $from = Configuration::get('PS_SHOP_EMAIL');
        $fromName = Configuration::get('PS_SHOP_NAME');
        $mailDir = dirname(__FILE__).'/../../mails/';
        $toName = $customer->firstname.' '.$customer->lastname;
        Mail::Send(
            $customer->id_lang,
            $template_name,
            $title,
            $templateVars,
            $customer->email,
            $toName,
            $from,
            $fromName,
            null,
            null,
            $mailDir
        );
    }

    /**
     * Send an e-mail to a customer, when his order received a trackingnumber from YellowCube.
     * @param string $reference The PrestaShop order reference</
     * @param string $id_lang The language id
     */
    public function sendBarEmail($reference, $id_lang)
    {
        $templateVars = array();
        $templateVars['{reference}'] = $reference;
        $template_name = Constants::TEMPLATENAMEBAR;
        $title = 'BAR Difference for Product '.$reference;
        $from = Configuration::get('PS_SHOP_EMAIL');
        $fromName = Configuration::get('PS_SHOP_NAME');
        $mailDir = dirname(__FILE__).'/../../mails/';
        $toName = 'ShopAdmin';
        Mail::Send(
            $id_lang,
            $template_name,
            $title,
            $templateVars,
            $from,
            $toName,
            $from,
            $fromName,
            null,
            null,
            $mailDir
        );
    }

    /**
     * Gets the email header in customer language
     * @param mixed $langId Language ID
     * @return string Email title
     */
    private static function getMailTitel($langId)
    {
        $lang = new Language($langId);
        $title = "";

        switch ($lang->iso_code) {
            case "de":
                $title = 'Sendungsverfolgung (Track & Trace) für Ihre Bestellung ';
                break;
            case "fr":
                $title = 'Suivi des envois de la commande ';
                break;
            case "it":
                $title = 'Monitorare gli invii d‘ordine ';
                break;
            default:
                $title = 'tracking number for order ';
                break;
        }

        return $title;
    }
}
