<?php
/**
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * Entwicklung: 	Zangger Websolutions
 * Web:			www.ihrewebagentur.ch
 * Projekt:		www.yellowcube.ihrewebagentur.ch
 * @version:		4.0
 */

?>
<!DOCTYPE html>
<html>
<head>
    <style>
        body {
            background-color: #ffcc00;
        }

        h1 {
            background-color: #ffcc00;
        }
    </style>
</head>

<body>
    <h1>YellowCube - Connectivity-Tester</h1>

    <?php
    include_once(dirname(__FILE__).'/libraries/YellowCubeService/yellowcubesoap.php');

    echo('Start Connectivity-Check: '.date("d.m.Y H:i:s"));

    echo '<br /> ';
    echo '<br /> ';

    if (class_exists("SOAPClient")) {
        echo('<b><font color="green">SOAP installed</font></b>');
        echo '<br /> ';
    } else {
        echo('<b><font color="red">SOAP not installed</font></b>');
        echo '<br /> ';
    }

    echo '<br /> ';

    echo('Initialise Test-Connectivity without Security-Check from Yellowcube Service');
    try {
        $url = 'https://service-test.swisspost.ch/apache/yellowcube-test/?wsdl';

        echo '<br /> ';
        echo("Url: ".$url);

        $client = new SoapClient($url, array('cache_wsdl' => WSDL_CACHE_NONE));

        $out = $client->__soapCall("getInventory", array(array(
        'ControlReference' => array(
            'Type' => 'BAR',
            'Sender' => 'Giveaways',
            'Receiver' => 'YELLOWCUBE',
            'Timestamp' => 19650206050505,
            'OperatingMode' => 'T',
            'Version' => '1.0',
        ))));

        /* echo '<br /> ';
         */
        echo '<br /> ';

        if ($out != null) {
            echo('<b><font color="green">Recieved BAR-Inventory from Testsystem</font></b>');
            echo '<br /> ';
            /* echo '<br /> ';
             */
        }

        echo('<b><font color="green">Connection to yellowcube-test works without cert</font></b>');
    } catch (Exception $e) {
        $errorText = htmlentities($e->faultstring);

        echo '<br /> ';
        echo '<br /> ';

        echo('<font color="red">'.$errorText.'</font>');
    }

    echo '<br /> ';
    echo '<br /> ';

    echo('--------------------------------------------------------------------------------');

    echo '<br /> ';
    echo '<br /> ';

    echo('Initialise INTEGRATION Yellowcube Service');
    try {
        $url = 'https://service-test.swisspost.ch/apache/yellowcube-int/?wsdl';

        echo '<br /> ';

        echo("Url: ".$url);

        $cert = dirname(__FILE__)."/cert/cert.pem";

        if (file_exists($cert)) {
            echo '<br /> ';
            echo '<br /> ';
            echo('<b><font color="green">Cert exist</font></b>');

            // instance the soap client
            $client = new YellowCubeSoap($url, array('local_cert' => $cert));

            $out = $client->__soapCall("getInventory", array(array(
            'ControlReference' => array(
                'Type' => 'BAR',
                'Sender' => 'Giveaways',
                'Receiver' => 'YELLOWCUBE',
                'Timestamp' => 19650206050505,
                'OperatingMode' => 'T',
                'Version' => '1.0',
            ))));

            echo '<br /> ';
            echo '<br /> ';

            if ($out != null) {
                echo('<b><font color="green">Recieved BAR from Testsystem</font></b>');
                echo '<br /> ';
            }

            echo('<b><font color="green">Connection to yellowcube-int works with authorised certificat</font></b>');
            echo '<br /> ';
            echo '<br /> ';
        } else {
            echo '<br /> ';
            echo '<br /> ';
            echo('<font color="red">Missing cert in the yellowcube/cert Folder</font>');
        }
    } catch (Exception $e) {
        $errorText = htmlentities($e->faultstring);

        echo '<br /> ';

        echo('<font color="red">'.$errorText.'</font>');
    }

    /* 		echo '<br /> ';
     */

    echo('--------------------------------------------------------------------------------');

    echo '<br /> ';
    echo '<br /> ';

    echo('Initialise Production Yellowcube Service');
    try {
        $url = 'https://service.swisspost.ch/apache/yellowcube/?wsdl';

        echo '<br /> ';

        echo("Url: ".$url);

        $cert = dirname(__FILE__)."/cert/cert.pem";

        if (file_exists($cert)) {
            echo '<br /> ';
            echo '<br /> ';
            echo('<b><font color="blue">Cert exist</font></b>');

            // instance the soap client
            $client = new YellowCubeSoap($url, array('local_cert' => $cert));

            $out = $client->__soapCall("getInventory", array(array(
            'ControlReference' => array(
                'Type' => 'BAR',
                'Sender' => 'Giveaways',
                'Receiver' => 'YELLOWCUBE',
                'Timestamp' => 19650206050505,
                'OperatingMode' => 'P',
                'Version' => '1.0',
            ))));

            echo '<br /> ';
            echo '<br /> ';

            if ($out != null) {
                echo('<b><font color="blue">Recieved BAR from PRODUCTION</font></b>');
                echo '<br /> ';
            }

            echo('<b><font color="blue">Connection to YC PRODUCTIONworks with authorised certificat</font></b>');
            echo '<br /> ';
        } else {
            echo '<br /> ';
            echo('<font color="red">Missing cert in the yellowcube/cert Folder</font>');
        }
    } catch (Exception $e) {
        $errorText = htmlentities($e->faultstring);

        echo '<br /> ';
        echo '<br /> ';

        echo('<font color="red">'.$errorText.'</font>');
    }
    echo '<br /> ';
    echo '<br /> ';

    echo('End Connectivity-Check: '.date("d.m.Y H:i:s"));

    echo '<br /> ';
    echo '<br /> ';
    echo('----------------------------------END-----------------------------------------');
    echo '<br /> ';
    ?>

</body>
</html>
