<?php
/**
 * AdminBarController short summary.
 *
 * Entwicklung: 	Zangger Websolutions
 * Web:			www.ihrewebagentur.ch
 * Projekt:		www.yellowcube.ihrewebagentur.ch
 * @version:		4.0
 */

include_once(dirname(__FILE__).'/../../classes/model/wab.php');
include_once(dirname(__FILE__).'/../../classes/dal/prestashopgateway.php');
include_once(dirname(__FILE__).'/../../yellowcube.php');

class AdminWabController extends AdminController
{

    protected $module;
    protected $statuses_array = array();

    public function __construct()
    {
        $this->module = new YellowCube();
        $this->bootstrap = true;
        $this->addRowAction('send'); //add a delete button
        $this->addRowAction('delete'); //add a delete button
        $this->explicitSelect = true;
        $this->list_no_link = true;
        $this->path = _MODULE_DIR_."yellowcube";
        $this->table = 'yellowcube_orders'; //define the main table
        $this->className = 'Wab'; //define the module entity
        $this->identifier = "id"; //the primary key

        $this->_select = '
            a.`id`,
            os.`color`,
            os.`name`';

        $this->_join = 'LEFT JOIN `'._DB_PREFIX_.'yellowcube_state` os ON (os.`id` = a.`stateID`)';


        $statuses = PrestaShopGateway::getYellowCubeStates();
        foreach ($statuses as $status) {
            $this->statuses_array[$status['id']] = $status['name'];
        }


        //and define the field to display in the admin table
        $this->fields_list = array(
             'id' => array(
                  'title' => $this->module->l('ID'),
                  'align' => 'left',
                  'width' => 'auto'
              ),
              'yc_reference' => array(
                  'title' => $this->module->l('YC Reference'),
                  'align' => 'left',
                  'width' => 'auto'
              ),
              'presta_reference' => array(
                  'title' => $this->module->l('Presta Reference'),
                  'align' => 'left',
                  'width' => 'auto'
              ),
              'timestamp' => array(
                  'title' => $this->module->l('Timestamp'),
                  'align' => 'left',
                  'width' => 'auto'
              ),
              'statuscode' => array(
                  'title' => $this->module->l('Statuscode'),
                  'align' => 'left',
                  'width' => 'auto'
              ),
              'name' => array(
                'title' => $this->module->l('State'),
                'type' => 'select',
                'color' => 'color',
                'list' => $this->statuses_array,
                'filter_key' => 'os!id',
                'filter_type' => 'int',
                'order_key' => 'name'
            ),
              'statustext' => array(
                  'title' => $this->module->l('Statustext'),
                  'align' => 'left',
                  'width' => 'auto'
              ),
              'tracking' => array(
                  'title' => $this->module->l('Tracking'),
                  'align' => 'left',
                  'width' => 'auto'
              ),
          );

        parent::__construct();
    }


    public function displaySendLink($token, $id)
    {
        $tpl = $this->createTemplate(
            "..\..\..\../modules/yellowcube/views/templates/admin/yellowcube/helpers/list/list_action_send.tpl"
        );


        $tpl->assign(array(
            'href' => self::$currentIndex.'&token='.$token.'&'
            .$this->identifier.'='.$id.'&send'.$this->table.'=1',
                'action' => $this->module->l('Send')
        ));

        return $tpl->fetch();
    }

    public function initToolbar()
    {
        parent::initToolbar();
        unset($this->toolbar_btn['new']);
        unset($this->toolbar_btn['export']);
    }

    /*
    public function renderForm(){


        $this->context->smarty->assign(array(
            'mymodule_controller_url' => $this->context->link->getAdminLink('AdminWab'),//give the url for ajax query
        ));

        $more = $this->module->display($path, 'view/templates/admin/wab.tpl');

        return $more.parent::renderForm();
    }*/

    /**
     * postProcess handle every checks before saving products information
     *
     * @return void
     */
    public function postProcess()
    {
        parent::postProcess(); //ruft delete auf.
    }

    public function initProcess()
    {
        parent::initProcess();
        if (Tools::getValue('send'.$this->table)) {
            $this->display = 'send';
            $this->action = 'send';
        }
    }

    /**
     * Object Delete
     */
    public function processDelete()
    {
        if (Validate::isLoadedObject($object = $this->loadObject())) {
            if ($object->statuscode > 100) {
                $object->delete();

                return parent::processDelete();
            }
        }

        return false;
    }


    /**
     * Object Send
     */
    public function processSend()
    {
        if (Validate::isLoadedObject($object = $this->loadObject())) {
            if ($object->statuscode > 100) {
                $this->module->reSendOrder($object->id);

                return true;
            }
        }

        return false;
    }
}
